// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: DumpVector
// Author: Hassan Siddiqui
//
// Description: Dumps an STL Vector into a DAL dataset 
// for later viewing by dsplot. Useful for debugging.
//
// Modifications: See ChangeLog
// 
// $Id: DumpVector.h,v 1.1 1999/05/25 07:52:39 hsiddiqu Exp $

#ifndef DUMPVECTOR_H
#define DUMPVECTOR_H

// General classes
#include <iostream.h>
#include <vector.h>

// SAS-specific classes
#include "Dal.h"

// General utility functions
#include "Tracer.h"
#include "stringutil.h"

// Local classes

class DumpVector
{

public:

  static void go( const vector<double>& vect,
		  const string & outsetStr  = "vector_out.ds")
    {
      
      PROC;
  
      /* Open output dataset and column */

      DataSet * set   = dataSetServer->open(outsetStr, 
					    DataSet::Create);

      Table * table   = set->addTable("DMP_VECTOR", vect.size());

      Column * column = table->addColumn("VECTOR",
					 Column::Real32, 
					 "Dumped Vector");

      ColumnData * coldata = column->data();

      real32 * r32 = coldata->real32Data();

      /* Copy vector to column */
      unsigned int index = 0;
      for (vector<double>::const_iterator i = vect.begin();
	   i != vect.end();
	   ++i)
	{
	  //cout << "vect ["<< index << "] " << *i << endl;
	  r32[index] = *i;
	  ++index;
	}
    
      dataSetServer->close(set);

      ENDPROC;
    } 

};

#endif
