// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: GenericResponse
// Author: Hassan Siddiqui
//
// Description: 
// Abstract interface to various flavours of RMF
// data being used as part of this package.
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: GenericResponse.h,v 1.9 2000/09/21 15:34:35 hsiddiqu Exp $

#ifndef GenericResponse_H
#define GenericResponse_H

// General classes

#include <string>
#include <iostream.h>
#include <vector>

// SAS-specific classes
#include "CalServer.h" // IntervalVector defined here
#include "Dal.h"

// Utility functions
#include "Tracer.h"

// -----------------------------------------------------------------
// class GenericResponse

// Abstract interface to various flavours of RMF
// data being used as part of this package.

// -----------------------------------------------------------------

class GenericResponse
{

public:

  /* Constructor */

  GenericResponse(){};

  virtual ~GenericResponse(){};

  /** Channel range accessors */

  virtual const unsigned int   firstChannel()     const = 0;

  // CHANGE THIS: lastChannel() should be constructed from numberOfChannels.

  virtual const unsigned int   lastChannel()      const = 0;

  const unsigned int           numberOfChannels() const 
    { 
      PROC; 
      RETURN lastChannel() - firstChannel() + 1;
    }

  /** Response Accessors */

  virtual unsigned int           ebinFirstIndex()   const {PROC; RETURN 0;}
  unsigned int                   ebinLastIndex()    const 
    {
      PROC; 
      RETURN ebinFirstIndex() + numberOfEbins() - 1;
    }

  virtual       unsigned int     numberOfEbins()    const = 0;
  //  virtual const IntervalVector<double> ebins()      const = 0;

  virtual const Interval<double> ebins( unsigned int row ) const = 0;

  // Return response vector according to row position
  virtual const vector<double>   responseVector    ( unsigned int energy_iterator ) const = 0;

  // Return response vector according to energy NB: result can be a bit fuzzy
  virtual const vector<double>   responseVector    ( double energy ) const = 0;

  // Return response vector according to ebin (convenience function)
  const vector<double>   responseVector  ( const Interval<double>& ebin ) const
    { PROC; RETURN  responseVector( 0.5 * (ebin.lo() + ebin.hi()) ); }

  

  /** Ebounds Accessors */
  /* Note the size and range corresponds to that specified for the channel,
   so no accessors are needed to cover this. */
  virtual const BinnedAxis * ebounds()  const = 0;

};

#endif




